/**
 * @author [S. Mahdi Mir-Ismaili](https://mirismaili.github.io)
 * Created on 1398/2/6 (2019/4/26).
 */
export default class TextWrapper implements WrapOptions {
    private readonly tabLength_1;
    readonly continuationIndent: string;
    readonly tabLength: number;
    readonly wrapOn: number;
    readonly allowedExceedingCharacters: RegExp;
    readonly breakableCharacters: RegExp;
    constructor(wrapStyle?: WrapOptions);
    wrap(text: string, indents?: string): WrapResult;
    getVisualLength(s: string, visualOffset?: number): number;
    debug: {
        enable: (namespaces: string) => void;
        disable: () => string;
        setLog: (log: (...args: any[]) => any) => (...args: any[]) => any;
    };
}
export interface WrapResult {
    markers: number[];
    wrappedText: string;
}
export interface WrapOptions {
    continuationIndent?: string;
    tabLength?: number;
    wrapOn?: number;
    allowedExceedingCharacters?: RegExp;
    breakableCharacters?: RegExp;
}
export declare const DEF_WRAP_OPTIONS: WrapOptions;
